//#include <GL/glew.h>
#include <glad/glad.h>
#include <JGL/JGL.h>
#include <rewindow/types/window.h>
#include <iostream>
#include <LearnOpenGL/Shader.h>


#if defined(_WIN32) || defined(_WIN64)
#include <windows.h>
#endif

struct Character
{
    unsigned int TextureID; // ID handle of the glyph texture
    Vector2 Size;           // Size of glyph
    Vector2 Bearing;        // Offset from baseline to left/top of glyph
    unsigned int Advance;   // Offset to advance to next glyph
};

std::map<char, Character> Characters;
GLuint VAO, VBO;
const std::string vertexShader = "attribute vec4 coord;\n"
                                 "varying vec2 texpos;\n"
                                 "\n"
                                 "void main(void) {\n"
                                 "  gl_Position = vec4(coord.xy, 0, 1);\n"
                                 "  texpos = coord.zw;\n"
                                 "}\n"
                                 "";
const std::string fragmentShader = "varying vec2 texpos;\n"
                                   "uniform sampler2D tex;\n"
                                   "uniform vec4 color;\n"
                                   "\n"
                                   "void main(void) {\n"
                                   "  gl_FragColor = vec4(1, 1, 1, texture2D(tex, texpos).a) * color;\n"
                                   "}";

using J3ML::LinearAlgebra::Matrix4x4;



struct point {
    GLfloat x;
    GLfloat y;
    GLfloat s;
    GLfloat t;
};

class JGLDemoWindow : public ReWindow::RWindow
{
public:
    LearnOpenGL::Shader shader;

    JGLDemoWindow() : ReWindow::RWindow()
    {

    }

    void initGL()
    {
        gladLoadGL();

        glMatrixMode(GL_PROJECTION);
        glLoadIdentity();
        glOrtho(0, 1024, 768, 0, -1, 1);
        glMatrixMode(GL_MODELVIEW);

        glPixelStorei(GL_UNPACK_ALIGNMENT, 1);

        glEnable(GL_CULL_FACE);
        glEnable(GL_BLEND);
        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
        glEnable(GL_TEXTURE_2D);

        JGL::InitTextEngine();
    }


    void display()
    {
        glClear(GL_COLOR_BUFFER_BIT);
        JGL::RenderText("WHATS BOPPIN muth ~~~ niger ~~~ aphuqqa____?", 0.f, -100.f, 3.f);
        JGL::RenderText("CHINESE CHARCTERS DONT WORK", 0.f, -100.f, 1.f);
    }

    void OnRefresh(float elapsed) override
    {
        display();
        this->glSwapBuffers();
    }
    bool OnResizeRequest(const ReWindow::WindowResizeRequestEvent& e) override
    {

        return true;
    }
};

int main(int argc, char** argv)
{
    JGLDemoWindow* window = new JGLDemoWindow();

    window->init(RenderingAPI::OPENGL, "Window", 1280, 720, false);
    window->initGL();
    window->setResizable(true);
    while (window->isAlive())
    {
        window->pollEvents();
        window->refresh();
    }

    return 0;
}